#include <OneWire.h>
#include <DallasTemperature.h>

// The data wire from the DS18S20 is plugged into pin 2 on the Arduino
#define ONE_WIRE_BUS 2

// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);

void setup()
{
  // set the data rate for the SoftwareSerial port
  // For minicom testing
  //Serial.begin(115200);
  // For comunicating with the serial port on a Trimble receiver with 19200 baud rate
  Serial.begin(19200);
}

// This starts the main program - a loop that looks for the letter "R" from the serial connection. 
// If a "R" is received the Arduino will reply with the current temperature. 
void loop()
{
  // int val = 0;
  if (Serial.available() >0)
  {
    int val = Serial.read();
    if (val==82) // 82 is equal to "R"
    {
    //getting the voltage reading from the temperature sensor
    sensors.requestTemperatures(); // Send the command to get temperatures
    // This last line mimics the ascii output of a met station
    Serial.print("0R0,Dm=0#,Sm=0.0#,Ta=");Serial.print(sensors.getTempCByIndex(0),1); Serial.println("C,Ua=0.0P,Pa=1.000B,Rc=1.00M,Hc=1.0M");
    }
  }
}
